# SPDX-License-Identifier: BSD-3-Clause
# Copyright (c) 2024 GongEn Contributors

macro (gongen_add_dep dep_name) # TODO if it is already known, overwrite
	cmake_parse_arguments(_arg "PUBLIC" "PLATFORM" "STATIC_LIBS;SHARED_LIBS;INJECT_SOURCES;INCLUDE_DIRS" ${ARGN})
	if (NOT _arg_PLATFORM OR _arg_PLATFORM EQUAL ${gongen_platform})
		set(gongen_dep_${dep_name}_include_dirs ${_arg_INCLUDE_DIRS})
		set(gongen_dep_${dep_name}_static_libs ${_arg_STATIC_LIBS})
		set(gongen_dep_${dep_name}_shared_libs ${_arg_SHARED_LIBS})
		set(gongen_dep_${dep_name}_inject_sources ${_arg_INJECT_SOURCES})
		set(gongen_dep_${dep_name}_public ${_arg_PUBLIC})
	endif ()
	set(gongen_dep_${dep_name} TRUE)
endmacro ()

macro (gongen_target_use_dep_inject sources_list_name dep)
	list(APPEND ${sources_list_name} "${gongen_dep_${dep}_inject_sources}")
endmacro ()
macro (gongen_target_use_dep target dep)
	set(_scope PRIVATE)
	if (gongen_dep_${dep}_public)
		set(_scope PUBLIC)
	endif ()
	foreach (_dir IN LISTS gongen_dep_${dep}_include_dirs)
		target_include_directories(${target} ${_scope} ${_dir})
	endforeach ()
	foreach (_lib IN LISTS gongen_dep_${dep}_static_libs)
		target_link_libraries(${target} ${_scope} ${_lib})
	endforeach ()
	foreach (_lib IN LISTS gongen_dep_${dep}_shared_libs)
		target_link_libraries(${target} ${_scope} ${_lib})
	endforeach ()
endmacro ()

set(gongen_schema_banks)
macro (gongen_add_gsf_schema_bank bank_name schema_dir)
	# TODO for release mode, use schema bank installed in ~/.local/share/gongen/gsf/<bank>
	list(APPEND gongen_schema_banks "GEN_GSF_SCHEMA_BANK_${bank_name}=\"${schema_dir}\"")
endmacro ()

set(gongen_module_list)
macro (_gongen_add_module module_name)
	cmake_parse_arguments(_arg "" "" "DEPS;REQUIRE;SOURCE_FILES;SOURCE_DIRS;SOURCE_DIRS_REC" ${ARGN})
	set(gongen_mod_${module_name}_sources)
	foreach (_source_file IN LISTS _arg_SOURCE_FILES)
		list(APPEND gongen_mod_${module_name}_sources ${gongen_directory}/${_source_file})
	endforeach ()
	foreach (_source_dir IN LISTS _arg_SOURCE_DIRS)
		file(GLOB _new_files "${gongen_directory}/${_source_dir}/*.cpp")
		list(APPEND gongen_mod_${module_name}_sources ${_new_files})
	endforeach ()
	foreach (_source_dir IN LISTS _arg_SOURCE_DIRS_REC)
		file(GLOB_RECURSE _new_files "${gongen_directory}/${_source_dir}/*.cpp")
		list(APPEND gongen_mod_${module_name}_sources ${_new_files})
	endforeach ()
	set(gongen_mod_${module_name}_deps "${_arg_DEPS}")
	set(gongen_mod_${module_name}_require "${_arg_REQUIRE}")
	set(gongen_mod_${module_name} TRUE)
	list(APPEND gongen_module_list ${module_name})
endmacro ()
